'=============
'JACKWHEEL.BAS
'=============
'Coded by Dav, OCT/2021

'Press SPACE to stop wheel spinning.
'Stop the wheel on the pumkin 5 times.
'After each turn the wheel spins faster.
'If you miss one, counts starts over to 1.
'ESC will quit game


RANDOMIZE TIMER

SCREEN _NEWIMAGE(640, 640, 32)
_FULLSCREEN _SQUAREPIXELS

wheel& = _LOADIMAGE("wheel.png")
wheelmark& = _LOADIMAGE("wheelmark.png")
wheelclick& = _SNDOPEN("wheelclick.wav")
_DISPLAY

pick = 1
sndcnt = 1

DO
    CLS , _RGB(99, 49, 0)
    RotoZoom3 _WIDTH / 2, _HEIGHT / 2, wheel&, 1, 1, _D2R(r)
    r = r + pick: IF r > 360 THEN r = 1
    _PUTIMAGE (315, 55), wheelmark&
    PPRINT 280, 290, 50, _RGB(255, 255, 255), 255, STR$(pick)
    _DISPLAY
    _LIMIT 110

    sndcnt = sndcnt + pick
    IF sndcnt > 40 THEN
        _SNDPLAY wheelclick&
        sndcnt = 1
    END IF

    IF INKEY$ = " " THEN
        _DELAY .5
        IF r >= 96 AND r <= 132 THEN
            pick = pick + 1
            IF pick > 5 THEN
                EXIT DO
            ELSE
                _SNDPLAYFILE ("sfx_magic.ogg")
                LINE (0, 0)-(_WIDTH, _HEIGHT), _RGBA(0, 255, 0, 100), BF
                _DISPLAY
                _DELAY .5
            END IF
        ELSE
            _SNDPLAYFILE ("sfx_dropdown.ogg")
            LINE (0, 0)-(_WIDTH, _HEIGHT), _RGBA(255, 0, 0, 100), BF
            _DISPLAY
            _DELAY .5
            pick = 1
        END IF
    END IF

    IF INP(&H60) = 1 THEN SYSTEM

    _KEYCLEAR
LOOP


_SNDPLAYFILE ("sfx_clap.ogg")

temp& = _COPYIMAGE(_DISPLAY)
FOR s = 1 TO 5 STEP .02
    RotoZoom3 _WIDTH / 2, _HEIGHT / 2, temp&, s, s, _D2R(r)
    r = r + pick: IF r >= 360 THEN r = 1
    _DISPLAY
    _LIMIT 100
NEXT
_FREEIMAGE temp&

FadeScreenOut

END


SUB FadeScreenOut
    ' Fade screen out
    img& = _COPYIMAGE(_DISPLAY)
    FOR i% = 0 TO 255 STEP 7
        _LIMIT 60 'control fade speed
        _PUTIMAGE (0, 0)-(_WIDTH, _HEIGHT), img&
        LINE (0, 0)-(_WIDTH, _HEIGHT), _RGBA(0, 0, 0, i%), BF 'increase black box transparency
        _DISPLAY
    NEXT
    _FREEIMAGE img&
END SUB

SUB PPRINT (x, y, size, clr&, trans&, text$)
    'This sub outputs to the current _DEST set
    'It makes trans& the transparent color

    'x/y is where to print text
    'size is the font size to use
    'clr& is the color of your text
    'trans& is the background transparent color
    'text$ is the string to print

    '=== get users current write screen
    orig& = _DEST

    '=== if you are using an 8 or 32 bit screen
    bit = 32: IF _PIXELSIZE(0) = 1 THEN bit = 256

    '=== step through your text
    FOR t = 0 TO LEN(text$) - 1
        '=== make a temp screen to use
        pprintimg& = _NEWIMAGE(16, 16, bit)
        _DEST pprintimg&
        '=== set colors and print text
        CLS , trans&: COLOR clr&
        PRINT MID$(text$, t + 1, 1);
        '== make background color the transprent one
        _CLEARCOLOR _RGB(0, 0, 0), pprintimg&
        '=== go back to original screen  to output
        _DEST orig&
        '=== set it and forget it
        x1 = x + (t * size): x2 = x1 + size
        y1 = y: y2 = y + size
        _PUTIMAGE (x1 - (size / 2), y1)-(x2, y2 + (size / 3)), pprintimg&
        _FREEIMAGE pprintimg&
    NEXT
END SUB


SUB RotoZoom3 (X AS LONG, Y AS LONG, Image AS LONG, xScale AS SINGLE, yScale AS SINGLE, radianRotation AS SINGLE)
    DIM px(3) AS SINGLE: DIM py(3) AS SINGLE ' simple arrays for x, y to hold the 4 corners of image
    DIM W&, H&, sinr!, cosr!, i&, x2&, y2& '   variables for image manipulation
    W& = _WIDTH(Image&): H& = _HEIGHT(Image&)
    px(0) = -W& / 2: py(0) = -H& / 2 'left top corner
    px(1) = -W& / 2: py(1) = H& / 2 ' left bottom corner
    px(2) = W& / 2: py(2) = H& / 2 '  right bottom
    px(3) = W& / 2: py(3) = -H& / 2 ' right top
    sinr! = SIN(-radianRotation): cosr! = COS(-radianRotation) ' rotation helpers
    FOR i& = 0 TO 3 ' calc new point locations with rotation and zoom
        x2& = xScale * (px(i&) * cosr! + sinr! * py(i&)) + X: y2& = yScale * (py(i&) * cosr! - px(i&) * sinr!) + Y
        px(i&) = x2&: py(i&) = y2&
    NEXT
    _MAPTRIANGLE _SEAMLESS(0, 0)-(0, H& - 1)-(W& - 1, H& - 1), Image TO(px(0), py(0))-(px(1), py(1))-(px(2), py(2))
    _MAPTRIANGLE _SEAMLESS(0, 0)-(W& - 1, 0)-(W& - 1, H& - 1), Image TO(px(0), py(0))-(px(3), py(3))-(px(2), py(2))
END SUB

